// HexaBot 'Move' engine
//

void doMoveModes() {
  // ' Move' engine main loop
  if (moveModeLast != moveMode) {
    moveModeLast = moveMode;
    if (moveMode < 1) {dirFlg = 0; setRGBEnh();}
//    Serial.print("ME_Mode="); Serial.println(moveMode);
  }
  switch (moveMode) {
    case 0:
      // In RESET, Rest or passing through state
      // keep an eye on JoyPad values
      moveInterval = 5000; // reset loop rate to 5ms
      if ((servoOE < 1) && (upDwnFlg > 0)) {
        // if PWM ON and stood up then respond to JoyPad
        if (JoyX > JoyCentreUL) {dirFlg = 2; setMoveTurnRight();}
        if (JoyX < JoyCentreLL) {dirFlg = 4; setMoveTurnLeft();}
        if (JoyY > JoyCentreUL) {dirFlg = 1; setMoveForward();}
        if (JoyY < JoyCentreLL) {dirFlg = 3; setMoveBackward();}
      }
      break;
    case 1:
      // waits for 'Rest' to be triggered
      break;
    case modeToRest:
      // 'Rest' movement
      moveToRest(); break;
    case 10:
      // 'Stand' movement
      moveToStand(); break;
    case modeForward:
      // Forward movement
      moveForward(); break;
    case modeBackward:
      // Backward movement
      moveBackward(); break;
    case modeTurnRht:
      // Turn right movement
      moveTurnRight(); break;
    case modeTurnLft:
      // Turn left movement
      moveTurnLeft(); break;
    case modePause:
      // 'Move' engine is in pause count-down
      moveInterval = 5000; // ensure 5ms count interval
      movePause--; if (movePause < 1) {moveMode = moveNext;}
      break;
  }
}

// ----------------------------------------------------------------------

void lowerLeft2Right1() {
  // lower front and rear left legs and centre right
  long zlowerAngle = strideAngleVar; // default max movement
  switch (lowerIncCnt) {
    case 1: zlowerAngle = strideAngleVar; break;
    case 2: zlowerAngle = ((raiseAngleVar-strideAngleVar)/5)+strideAngleVar; break;
    case 3: zlowerAngle = ((2*(raiseAngleVar-strideAngleVar))/5)+strideAngleVar; break;
    case 4: zlowerAngle = ((3*(raiseAngleVar-strideAngleVar))/5)+strideAngleVar; break;
    case 5: zlowerAngle = ((4*(raiseAngleVar-strideAngleVar))/5)+strideAngleVar; break;
  } lowerIncCnt--; // decrement pointer for next call
  SetServoAngle(4, zlowerAngle); // lower front left leg
  SetServoAngle(6, zlowerAngle); // lower centre right leg
  SetServoAngle(12, zlowerAngle); // lower rear left leg
}

// ----------------------------------------------------------------------

void lowerRight2Left1() {
  // lower front and rear right legs and centre left
  long zlowerAngle = strideAngleVar; // default max movement
  switch (lowerIncCnt) {
    case 1: zlowerAngle = strideAngleVar; break;
    case 2: zlowerAngle = ((raiseAngleVar-strideAngleVar)/5)+strideAngleVar; break;
    case 3: zlowerAngle = ((2*(raiseAngleVar-strideAngleVar))/5)+strideAngleVar; break;
    case 4: zlowerAngle = ((3*(raiseAngleVar-strideAngleVar))/5)+strideAngleVar; break;
    case 5: zlowerAngle = ((4*(raiseAngleVar-strideAngleVar))/5)+strideAngleVar; break;
  } lowerIncCnt--; // decrement pointer for next call
  SetServoAngle(2, zlowerAngle); // lower front right leg
  SetServoAngle(8, zlowerAngle); // lower centre left leg
  SetServoAngle(10, zlowerAngle); // lower rear right leg
}

// ----------------------------------------------------------------------

void moveBackward() {
  // move backwards at a pace set by JoyY
  moved = 400; // set 'Rest' time-out to 2s
  anyCalc = 0; // restrict calculations to specific moveWalks
  switch (moveWalk) {
    case 0:
      // move legs to stride position
      SetToLegPos(strideAngleVar); 
      moveWalk++; setRGBEnh(); delay(100); break;
    case 1:
      // raise three legs
      anyVal = random(2); // randomly decide which start side
      if (anyVal < 1) {
        raiseRight2Left1(); moveSide = 0; // left side primary
      } else {
        raiseLeft2Right1(); moveSide = 1; // right side primary
      } moveWalk++; setMovePause(10);
      steerFlag = 0; moveAngleMu = 1.0; break;
    case 2:
      // move shoulders in non-overlapped region
      anyCalc = 1; moveAngle--;
      if (moveAngle == restAngle) {moveAngleFP = float(restAngle);} // resynch
      if (moveAngleFP <= 90.0) {moveAngleFP += moveIncFP;}
      anyA0 = int(moveAngleFP);
      anyA1 = int(((moveAngleFP - 65.0) * moveAngleMu) + 65.0);
      anyA2 = int(((float(moveAngle) - 65.0) * moveAngleMu) + 65.0);
      if (moveSide < 1) {
        // left side primary
        if (steerFlag < 0) {
          // steering to the left
          setLeft2Right1(anyA2,moveAngle,anyA2);
          setRight2Left1(anyA0,anyA1,anyA0);
        } else if (steerFlag > 0) {
          // steering to the right
          setLeft2Right1(moveAngle,anyA2,moveAngle);
          setRight2Left1(anyA1,anyA0,anyA1);
        } else {
          // no steering applied
          setLeft2Right1(moveAngle,moveAngle,moveAngle);
          setRight2Left1(anyA0,anyA0,anyA0);
        }
        if (raiseIncCnt > 0) {raiseRight2Left1();}
      } else {
        // right side primary
        if (steerFlag < 0) {
          // steering to the left
          setRight2Left1(moveAngle,anyA2,moveAngle);
          setLeft2Right1(anyA1,anyA0,anyA1);
        } else if (steerFlag > 0) {
          // steering to the right
          setRight2Left1(anyA2,moveAngle,anyA2);
          setLeft2Right1(anyA0,anyA1,anyA0);
        } else {
          // no steering applied
          setRight2Left1(moveAngle,moveAngle,moveAngle);
          setLeft2Right1(anyA0,anyA0,anyA0);
        }
        if (raiseIncCnt > 0) {raiseLeft2Right1();}
      }
      if (moveAngle <= 44) {
        // hit overlap region so drop raised legs
        lowerIncCnt = 5;
        if (moveSide < 1) {
          lowerRight2Left1();
        } else {
          lowerLeft2Right1();
        } moveWalk++;
      } break;
    case 3:
      // move shoulders in overlapped region
      anyCalc = 1;
      moveAngle--; anyA0 = moveAngle + 47;
      moveAngleFP = float(anyA0);
      anyA1 = int(((moveAngleFP - 65.0) * moveAngleMu) + 65.0);
      anyA2 = int(((float(moveAngle) - 65.0) * moveAngleMu) + 65.0);
      if (moveSide < 1) {
        // left side primary
        if (steerFlag < 0) {
          // steering to the left
          setLeft2Right1(anyA2,moveAngle,anyA2);
          setRight2Left1(anyA0,anyA1,anyA0);
        } else if (steerFlag > 0) {
          // steering to the right
          setLeft2Right1(moveAngle,anyA2,moveAngle);
          setRight2Left1(anyA1,anyA0,anyA1);
        } else {
          // no steering applied
          setLeft2Right1(moveAngle,moveAngle,moveAngle);
          setRight2Left1(anyA0,anyA0,anyA0);
        }
        if (lowerIncCnt > 0) {lowerRight2Left1();}
      } else {
        // right side primary
        if (steerFlag < 0) {
          // steering to the left
          setRight2Left1(moveAngle,anyA2,moveAngle);
          setLeft2Right1(anyA1,anyA0,anyA1);
        } else if (steerFlag > 0) {
          // steering to the right
          setRight2Left1(anyA2,moveAngle,anyA2);
          setLeft2Right1(anyA0,anyA1,anyA0);
        } else {
          // no steering applied
          setRight2Left1(moveAngle,moveAngle,moveAngle);
          setLeft2Right1(anyA0,anyA0,anyA0);
        }
        if (lowerIncCnt > 0) {lowerLeft2Right1();}
      }
      if (moveAngle <= 40) {
        // at end of swing
        moveAngle = anyA0; moveAngleFP = 40;
        raiseIncCnt = 5;
        if (moveSide > 0) {
          raiseRight2Left1(); moveSide = 0; // left side primary
        } else {
          raiseLeft2Right1(); moveSide = 1; // right side primary
        }
        moveWalk = 2; // go back to non-overlapped phase
      } break;
  }
  // adjust 'Move' loop timing rate
  if ((anyCalc > 0) && (JoyY < JoyCentreLL)){
    unsigned long zVal = JoyY;
    if (JoyY < 50) {
      // lower controller shapping - quick band
      if (speedTQ > 0) {
        // 'Quick' mode
        zVal = (zVal *6000) / 49;
        zVal = 4000 + zVal;
      } else {
        // 'Tortoise' mode
        zVal = (zVal *6000) / 49;
        zVal = 12000 + zVal;
      }
    } else {
      // upper controller shapping - slow band
      if (speedTQ > 0) {
        // 'Quick' mode
        zVal = (zVal - 49) * 20000;
        zVal = zVal/49;
        zVal = 10000 + zVal;
      } else {
        // 'Tortoise' mode
        zVal = (zVal - 49) * 32000;
        zVal = zVal/49;
        zVal = 18000 + zVal;
      }
    }
    zVal = max(zVal,3000);
    if (moveInterval != zVal) {
      moveInterval = zVal;
//      Serial.print("moveInterval = "); Serial.println(moveInterval);
    }
    // Variable height adjustment
//    if (JoyY < JoyCentreLL) {
//      // only if Y demand is backwards
//      raiseAngleVar = (raiseAngle - raiseAngleLL) * (JoyCentreLL - JoyY);
//      raiseAngleVar = raiseAngle - (raiseAngleVar/JoyCentreLL);
//    }
    // check steering
    if ((JoyX >= JoyCentreLL) && (JoyX <= JoyCentreUL)) {
      // centre deadband no steering
      steerFlag = 0; moveAngleMu = 1.0;
    } else if (JoyX < JoyCentreLL) {
      // steering to the left, JX= 0 - 97, multiplier= 0.20 - 1.0
      steerFlag = -1; moveAngleMu = 0.20 + (float(JoyX)/121.3);
    } else {
      // steering to the right, JX= 159 - 255, multiplier 1.0 - 0.20
      steerFlag = 1; moveAngleMu = 0.20 + ((255.0 - float(JoyX))/120.0);
    }
  }
  // test for 'Forward' demand on JoyPad
  if (JoyY > JoyCentreLL){
    // reverse direction so reset shoulder angles and exit
    moveToReady(); moveMode = 0;
  }
  // test for no demand on JoyPad
  if ((JoyX > JoyCentreLL) && (JoyX < JoyCentreUL) && (JoyY > JoyCentreLL) && (JoyY < JoyCentreUL)){
    // stationary so exit moving backward
    moveMode = 0;
  }
}

// ----------------------------------------------------------------------

void moveForward() {
  // move forward at a pace set by JoyY
  moved = 400; // set 'Rest' time-out to 2s
  anyCalc = 0; // restrict calculations to specific moveWalks
  switch (moveWalk) {
    case 0:
      // move legs to stride position
      SetToLegPos(strideAngleVar); 
      moveWalk++; setRGBEnh(); delay(100); break;
    case 1:
      // raise three legs
      anyVal = random(2); // randomly decide which start side
      if (anyVal < 1) {
        raiseRight2Left1(); moveSide = 0; // left side primary
      } else {
        raiseLeft2Right1(); moveSide = 1; // right side primary
      } moveWalk++; setMovePause(10);
      steerFlag = 0; moveAngleMu = 1.0; break;
    case 2:
      // move shoulders in non-overlapped region
      anyCalc = 1; moveAngle++;
      if (moveAngle == restAngle) {moveAngleFP = float(restAngle);} // resynch
      if (moveAngleFP > 40.0) {moveAngleFP -= moveIncFP;}
      anyA0 = int(moveAngleFP);
      anyA1 = int(((moveAngleFP - 65.0) * moveAngleMu) + 65.0);
      anyA2 = int(((float(moveAngle) - 65.0) * moveAngleMu) + 65.0);
      if (moveSide < 1) {
        // left side primary
        if (steerFlag < 0) {
          // steering to the left
          setLeft2Right1(anyA2,moveAngle,anyA2);
          setRight2Left1(anyA0,anyA1,anyA0);
        } else if (steerFlag > 0) {
          // steering to the right
          setLeft2Right1(moveAngle,anyA2,moveAngle);
          setRight2Left1(anyA1,anyA0,anyA1);
        } else {
          // no steering applied
          setLeft2Right1(moveAngle,moveAngle,moveAngle);
          setRight2Left1(anyA0,anyA0,anyA0);
        }
        if (raiseIncCnt > 0) {raiseRight2Left1();}
      } else {
        // right side primary
        if (steerFlag < 0) {
          // steering to the left
          setRight2Left1(moveAngle,anyA2,moveAngle);
          setLeft2Right1(anyA1,anyA0,anyA1);
        } else if (steerFlag > 0) {
          // steering to the right
          setRight2Left1(anyA2,moveAngle,anyA2);
          setLeft2Right1(anyA0,anyA1,anyA0);
        } else {
          // no steering applied
          setRight2Left1(moveAngle,moveAngle,moveAngle);
          setLeft2Right1(anyA0,anyA0,anyA0);
        }
        if (raiseIncCnt > 0) {raiseLeft2Right1();}
      }
      if (moveAngle >= 86) {
        // hit overlap region so drop raised legs
        lowerIncCnt = 5;
        if (moveSide < 1) {
          lowerRight2Left1();
        } else {
          lowerLeft2Right1();
        } moveWalk++;
      } break;
    case 3:
      // move shoulders in overlapped region
      anyCalc = 1;
      moveAngle++; anyA0 = moveAngle - 47;
      moveAngleFP = float(anyA0);
      anyA1 = int(((moveAngleFP - 65.0) * moveAngleMu) + 65.0);
      anyA2 = int(((float(moveAngle) - 65.0) * moveAngleMu) + 65.0);
      if (moveSide < 1) {
        // left side primary
        if (steerFlag < 0) {
          // steering to the left
          setLeft2Right1(anyA2,moveAngle,anyA2);
          setRight2Left1(anyA0,anyA1,anyA0);
        } else if (steerFlag > 0) {
          // steering to the right
          setLeft2Right1(moveAngle,anyA2,moveAngle);
          setRight2Left1(anyA1,anyA0,anyA1);
        } else {
          // no steering applied
          setLeft2Right1(moveAngle,moveAngle,moveAngle);
          setRight2Left1(anyA0,anyA0,anyA0);
        }
        if (lowerIncCnt > 0) {lowerRight2Left1();}
      } else {
        // right side primary
        if (steerFlag < 0) {
          // steering to the left
          setRight2Left1(moveAngle,anyA2,moveAngle);
          setLeft2Right1(anyA1,anyA0,anyA1);
        } else if (steerFlag > 0) {
          // steering to the right
          setRight2Left1(anyA2,moveAngle,anyA2);
          setLeft2Right1(anyA0,anyA1,anyA0);
        } else {
          // no steering applied
          setRight2Left1(moveAngle,moveAngle,moveAngle);
          setLeft2Right1(anyA0,anyA0,anyA0);
        }
        if (lowerIncCnt > 0) {lowerLeft2Right1();}
      }
      if (moveAngle >= 90) {
        // at end of swing
        moveAngle = anyA0; moveAngleFP = 90;
        raiseIncCnt = 5;
        if (moveSide > 0) {
          raiseRight2Left1(); moveSide = 0; // left side primary
        } else {
          raiseLeft2Right1(); moveSide = 1; // right side primary
        }
        moveWalk = 2; // go back to non-overlapped phase
      } break;
  }
  // adjust 'Move' loop timing rate
  if ((anyCalc > 0) && (JoyY > JoyCentreUL)){
    unsigned long zVal = JoyY;
    if (JoyY < 206) {
      // lower controller shapping - slow band
      if (speedTQ > 0) {
        // 'Quick' mode
        zVal = 20000 * (zVal - JoyCentreUL);
        zVal = zVal/(206-JoyCentreUL);
        zVal = 30000 - zVal;
      } else {
        // 'Tortoise' mode
        zVal = 32000 * (zVal - JoyCentreUL);
        zVal = zVal/(206-JoyCentreUL);
        zVal = 50000 - zVal;
      }
    } else {
      // upper controller shapping - quick band
      if (speedTQ > 0) {
        // 'Quick' mode
        zVal = 11877 * (zVal - JoyCentreUL);
        zVal = zVal/(255-JoyCentreUL);
        zVal = 15877 - zVal;
      } else {
        // 'Tortoise' mode
        zVal = 11877 * (zVal - JoyCentreUL);
        zVal = zVal/(255-JoyCentreUL);
        zVal = 23877 - zVal;
      }
    }
    zVal = max(zVal,3000);
    if (moveInterval != zVal) {
      moveInterval = zVal;
//      Serial.print("moveInterval = "); Serial.println(moveInterval);
    }
    // Variable heigh adjustment
//    if (JoyY > JoyCentreUL) {
//      // only if Y demand is forwards
//      raiseAngleVar = (raiseAngle - raiseAngleLL) * (JoyY - JoyCentreUL);
//      raiseAngleVar = raiseAngle - (raiseAngleVar/(255 - JoyCentreUL));
//    }
    // check steering
    if ((JoyX >= JoyCentreLL) && (JoyX <= JoyCentreUL)) {
      // centre deadband no steering
      steerFlag = 0; moveAngleMu = 1.0;
    } else if (JoyX < JoyCentreLL) {
      // steering to the left, JX= 0 - 97, multiplier= 0.20 - 1.0
      steerFlag = -1; moveAngleMu = 0.20 + (float(JoyX)/121.3);
    } else {
      // steering to the right, JX= 159 - 255, multiplier 1.0 - 0.20
      steerFlag = 1; moveAngleMu = 0.20 + ((255.0 - float(JoyX))/120.0);
    }
//    Serial.print("Mu="); Serial.println(moveAngleMu);
  }
  // test for 'Backward' demand on JoyPad
  if (JoyY < JoyCentreUL){
    // reverse direction so reset shoulder angles and exit
    moveToReady(); moveMode = 0;
  }
  // test for no demand on JoyPad
  if ((JoyX > JoyCentreLL) && (JoyX < JoyCentreUL) && (JoyY > JoyCentreLL) && (JoyY < JoyCentreUL)){
    // stationary so exit moving forward
    moveMode = 0;
  }
}

// ----------------------------------------------------------------------

void moveHead() {
  // moves head to random positions of 0-15-30-45-60-75-90
  int zVal;
  switch (headSweep) {
    case 1:
      zVal = servoAng[0] + headInc;
      SetServoAngle(0, zVal);
//      Serial.println(zVal);
//      Serial.print("Angle=");
//      Serial.println(servoAng[0]);
//      Serial.print("Tgt=");
//      Serial.println(headTgt);
//      Serial.print("Min=");
//      Serial.println(headMin);
//      Serial.print("Max=");
//      Serial.println(headMax);
      break;
    case 2:
      // trigger range if angle matches
      rangeFlag = 0;
      switch (servoAng[0]) {
        case 0: trigHCSR04 (); rangeFlag = 5; break;
        case 18: trigHCSR04 (); rangeFlag = 6; break;
        case 36: trigHCSR04 (); rangeFlag = 7; break;
        case 54: trigHCSR04 (); rangeFlag = 8; break;
        case 72: trigHCSR04 (); rangeFlag = 9; break;
        case 90: trigHCSR04 (); rangeFlag = 10; break;
      } break;
    case 3:
      // only one cycle needed to get a valid range
      if (rangeTIR > 0) {rangeTIR--;}
      if (rangeFlag > 0) {
        if (intFlag > 0) {
          // an interrupt occured during the 5ms wait period
//          Serial.print("Time=");
//          Serial.print(intMicros);
//          Serial.println("us");
//          Serial.print("Angle=");
//          Serial.println(servoAng[0]);
//          Serial.print("Distance=");
//          Serial.print((intMicros/58)-9);
//          Serial.println("cm");
          rangeVal = (intMicros/58)-9;
        } else {
          intFlag = 1; // prevent interrupts from recording
          rangeVal = 170; // set to max range
//          Serial.println("No Range");
        }
        if (rangeVal>33) {strip.setPixelColor(rangeFlag,strip.Color(0,0,4));}
        else if (rangeVal>30) {strip.setPixelColor(rangeFlag,strip.Color(0,3,4)); rangeTIR = 180;}
        else if (rangeVal>27) {strip.setPixelColor(rangeFlag,strip.Color(0,12,0)); rangeTIR = 180;}
        else if (rangeVal>24) {strip.setPixelColor(rangeFlag,strip.Color(0,17,0)); rangeTIR = 180;}
        else if (rangeVal>21) {strip.setPixelColor(rangeFlag,strip.Color(11,11,0)); rangeTIR = 180;}
        else if (rangeVal>18) {strip.setPixelColor(rangeFlag,strip.Color(18,9,0)); rangeTIR = 180;}
        else {strip.setPixelColor(rangeFlag,strip.Color(32,0,0)); rangeTIR = 180;}
        strip.show();
      } break;
    case 4:
      // here after 5 x loop cycle 5ms
      if ((servoAng[0] == headTgt)||(servoAng[0]<=headMin)||(servoAng[0]>=headMax)) {
        // reached target angle
        headSweep = 98;
      } else {headSweep = 0;}
      break;
    case 99:
      // set a new position
      headMin = 0; headMax = 90;
      if ((servoAng[1] < 1) || (servoAng[3] < 1)) {
        // legs are facing forward so limit sweep range
        headMin = 25; headMax = 65;
      } headTgt = servoAng[0];
      if (rangeTIR > 0) {
        // target in range so sweep end to end to set all RGB LEDs
        if (headTgt > headMin) {headTgt = headMin;} else {headTgt = headMax;}
      } else {
        // no target in range so random sweep
        while (headTgt == servoAng[0]) {
          headTgt = 15 * random(7);
        } headTgt = min(headMax,headTgt); headTgt = max(headMin,headTgt);
      }
      if (headTgt > servoAng[0]) {headInc = 1;}
      else {headInc = -1;}
//      Serial.print("Tgt=");
//      Serial.println(headTgt);
      headSweep = 0; break;
    case 100:
      // set headSweep to this for a 5s delay to head movement
      break;
    case 300:
      // set headSweep to this for a 4s delay to head movement
      break;
    case 500:
      // set headSweep to this for a 3s delay to head movement
      break;
    case 700:
      // set headSweep to this for a 2s delay to head movement
      break;
    case 900:
      // set headSweep to this for a 1s delay to head movement
      break;
    case 1100:
      // break out of delayed start mode
      headSweep = 98; break;
    case 2000:
      // static head with range sensor lighting whole body
      SetServoAngle(0, 45); break;
    case 2001:
      // trigger range finder
      trigHCSR04 (); break;
    case 2002:
      if (intFlag > 0) {
        // an interrupt occured during the 5ms wait period
        rangeVal = (intMicros/58)-9;
      } else {
        intFlag = 1;
        if (rangeVal < 36) {rangeVal++;}
      }
      if (rangeVal>33) {SetPixiColours(0,0,0,0,0,4,4,4,4,4,4,0,0,0,0,0);}
      else if (rangeVal>30) {SetPixiColours(0,0,0,0,0,0x000304,0x000304,0x000304,0x000304,0x000304,0x000304,0,0,0,0,0);}
      else if (rangeVal>27) {SetPixiColours(0,0,0,0,0x000C00,0x000C00,0x000C00,0x000C00,0x000C00,0x000C00,0x000C00,0x000C00,0,0,0,0);}
      else if (rangeVal>24) {SetPixiColours(0,0,0,0x001100,0x001100,0x001100,0x001100,0x001100,0x001100,0x001100,0x001100,0x001100,0x001100,0,0,0);}
      else if (rangeVal>21) {SetPixiColours(0,0,0x0B0B00,0x0B0B00,0x0B0B00,0x0B0B00,0x0B0B00,0x0B0B00,0x0B0B00,0x0B0B00,0x0B0B00,0x0B0B00,0x0B0B00,0x0B0B00,0,0);}
      else if (rangeVal>18) {SetPixiColours(0,0x110900,0x110900,0x110900,0x110900,0x110900,0x110900,0x110900,0x110900,0x110900,0x110900,0x110900,0x110900,0x110900,0x110900,0);}
      else {SetPixiColours(0x320000,0x320000,0x320000,0x320000,0x320000,0x320000,0x320000,0x320000,0x320000,0x320000,0x320000,0x320000,0x320000,0x320000,0x320000,0x320000);}
      strip.show(); break;
    case 2003:
      // check automodes
      switch (autoMode) {
        case 1:
          // set speed in back-off mode
          if (rangeVal>36) {JoyY = 128;}
          else {JoyY = 96 - ((96 * (36-rangeVal))/36);}
          JoyY = max(0,min(128,JoyY)); JoyX = 128; break;
        case 2:
          // set speed in chase mode
          if ((rangeVal<8)||(rangeVal>36)) {JoyY = 128;}
          else {JoyY = 255 - ((95 * (36-rangeVal))/36);}
          JoyY = max(128,min(255,JoyY)); JoyX = 128; break;
        case 3:
          // set speed in track mode, with 3cm centre dead band
          if ((rangeVal<8)||(rangeVal>36)) {JoyY = 128;}
          else if (rangeVal<21) {
            // set speed in back-off mode
            JoyY = 96 - ((96 * (21-rangeVal))/13);
            JoyY = max(0,min(128,JoyY));
          } else if (rangeVal>23) {
            // set speed in chase mode
            JoyY = 255 - ((95 * (36-rangeVal))/14);
            JoyY = max(128,min(255,JoyY));
          } else {JoyY = 128;} // dead band
          JoyX = 128; break;
      }
      Serial.print("JoyY="); Serial.println(JoyY);
      break;
    case 2005:
      // repeat the cycle
      headSweep = 1999; break;
  } headSweep++;
}

// ----------------------------------------------------------------------

void moveToReady() {
  // move to a leg position ready for next move
  // restAngle = shoulder target centre angle
  if (servoOE < 1) {
    // set ALL shoulder and legs to rest angles
    switch (legMode) {
      case 0: raiseAngleVar = 70; strideAngleVar = 38; break;
      case 1: raiseAngleVar = 75; strideAngleVar = 55; break;
      case 2: raiseAngleVar = 100; strideAngleVar = 38; break;
      case 3: raiseAngleVar = 90; strideAngleVar = 50; break;
    }
    SetToLegPos(strideAngleVar); // set height
    SetToParkPos(restAngle,1); // set movement start angle
  }
}

// ----------------------------------------------------------------------

void moveToReadyLegPos() {
  // move to a leg position ready for next move
  // restAngle = shoulder target centre angle
  SetToLegPos(strideAngleVar); // set height
  SetToParkPos(restAngle,0); // set movement start angle
}

// ----------------------------------------------------------------------

void moveToRest() {
  // move to a leg position which consumes minimum power
  // restAngle = shoulder target angle
  if (servoOE < 1) {
    moveInterval = 5000; 
    switch (moveRest) {
      case 0:
        // set ALL legs to rest angle
        SetToLegPos(restHeight); moveRest = 1; setMovePause(20); break;
        
      case 1:
        // raise rear left leg
        if (servoAng[11] != restAngle) {
          SetServoAngle(12, raiseAngle);
          moveRest++; setMovePause(8);
        } else {moveRest = 4;} // skip this leg
        break;
      case 2:
        // rotate rear left leg
        SetServoAngle(11, restAngle);
        moveRest++; setMovePause(8); break;
      case 3:
        // lower rear left leg
        SetServoAngle(12, restHeight);
        moveRest++; setMovePause(8); break;
  
      case 4:
        // raise rear right leg
        if (servoAng[9] != restAngle) {
          SetServoAngle(10, raiseAngle);
          moveRest++; setMovePause(8);
        } else {moveRest = 7;} // skip this leg
        break;
      case 5:
        // rotate rear right leg
        SetServoAngle(9, restAngle);
        moveRest++; setMovePause(8); break;
      case 6:
        // lower rear right leg
        SetServoAngle(10, restHeight);
        moveRest++; setMovePause(8); break;
  
      case 7:
        // raise centre left leg
        if (servoAng[7] != restAngle) {
          SetServoAngle(8, raiseAngle);
          moveRest++; setMovePause(8);
        } else {moveRest = 10;} // skip this leg
        break;
      case 8:
        // rotate centre left leg
        SetServoAngle(7, restAngle);
        moveRest++; setMovePause(8); break;
      case 9:
        // lower centre left leg
        SetServoAngle(8, restHeight);
        moveRest++; setMovePause(8); break;
  
      case 10:
        // raise centre right leg
        if (servoAng[5] != restAngle) {
          SetServoAngle(6, raiseAngle);
          moveRest++; setMovePause(8);
        } else {moveRest = 13;} // skip this leg
        break;
      case 11:
        // rotate centre right leg
        SetServoAngle(5, restAngle);
        moveRest++; setMovePause(8); break;
      case 12:
        // lower centre right leg
        SetServoAngle(6, restHeight);
        moveRest++; setMovePause(8); break;
  
      case 13:
        // raise front left leg
        if (servoAng[3] != restAngle) {
          SetServoAngle(4, raiseAngle);
          moveRest++; setMovePause(8);
        } else {moveRest = 16;} // skip this leg
        break;
      case 14:
        // rotate front left leg
        SetServoAngle(3, restAngle);
        moveRest++; setMovePause(8); break;
      case 15:
        // lower front left leg
        SetServoAngle(4, restHeight);
        moveRest++; setMovePause(8); break;
  
      case 16:
        // raise front right leg
        if (servoAng[1] != restAngle) {
          SetServoAngle(2, raiseAngle);
          moveRest++; setMovePause(8);
        } else {moveRest = 19;} // skip this leg
        break;
      case 17:
        // rotate front right leg
        SetServoAngle(1, restAngle);
        moveRest++; setMovePause(8); break;
      case 18:
        // lower front right leg
        SetServoAngle(2, restHeight);
        moveRest++; setMovePause(8); break;
        
      case 19:
        // move complete
        Serial.println("At 'Rest'");
        moveMode = 0; break;
    }
  }
}

// ----------------------------------------------------------------------

void moveToRestQuick() {
  // move to a leg position which consumes minimum power
  // restAngle = shoulder target angle
  if (servoOE < 1) {
    moveInterval = 5000; 
    // set ALL shoulder and legs to rest angles
    SetToLegPos(restHeight);
    SetToParkPos(restAngle,1);
  }
}

// ----------------------------------------------------------------------

void moveToStand() {
  // move legs to the standing position of 38 degrees
  if (servoOE < 1) {
    moveInterval = 5000;
    // set ALL leg angles
    SetToLegPos(restHeight); // move to default height
    // set ALL shoulder angles
    SetToParkPos(standAngle,1); // stand and centre head
    Serial.print("Standing at ");
    Serial.println(standAngle);
    moved = 200; // set 'Rest' time-out
    moveMode = 0; upDwnFlg = 1;
  }
}

// ----------------------------------------------------------------------

void moveTurnLeft() {
  // left turn in a circular manner at a pace set by JoyY
  moved = 400; // set 'Rest' time-out to 2s
  anyCalc = 0; // restrict calculations to specific moveWalks
  switch (moveWalk) {
    case 0:
      // move legs to stride position
      SetToLegPos(strideAngleVar); 
      moveWalk++; setRGBEnh(); setMovePause(20); break;
    case 1:
      // raise three legs
      anyVal = random(2); // randomly decide which start side
      if (anyVal < 1) {
        raiseLeft2Right1(); moveSide = 0; // left side primary
      } else {
        raiseRight2Left1(); moveSide = 1; // right side primary
      } moveWalk++; setMovePause(10);
      moveAngleMu = 1.0; break;
    case 2:
      // move shoulders in non-overlapped region
      // when turning we need to generate 4 angles
      anyCalc = 1; moveAngle++;
      if (moveAngle == restAngle) {moveAngleFP = float(restAngle);} // resynch
      anyA1 = restAngle + restAngle - moveAngle;
      if (moveAngleFP > 40.0) {
        moveAngleFP -= moveIncFP;
        anyFP = float(restAngle);
        anyFP = anyFP + anyFP - moveAngleFP;
      } anyA0 = int(moveAngleFP); anyA2 = int(anyFP);
      if (moveSide < 1) {
        // left side primary
        setLeft2Right1(moveAngle,anyA1,moveAngle); // legs down
        setRight2Left1(anyA2,anyA0,anyA2); // legs up
        if (raiseIncCnt > 0) {raiseLeft2Right1();}
      } else {
        // right side primary
        setLeft2Right1(anyA0,anyA2,anyA0); // legs up
        setRight2Left1(anyA1,moveAngle,anyA1); // legs down
        if (raiseIncCnt > 0) {raiseRight2Left1();}
      }
      if (moveAngle >= 86) {
        // hit overlap region so drop raised legs
        lowerIncCnt = 5;
        if (moveSide < 1) {
          lowerLeft2Right1();
        } else {
          lowerRight2Left1();
        } moveWalk++;
      } break;
    case 3:
      // move shoulders in overlapped region
      anyCalc = 1;
      moveAngle++; anyA0 = moveAngle - 47;
      anyA1 = 83 - anyA0; anyA2 = 177 - moveAngle;
      if (moveSide < 1) {
        // left side primary
        setLeft2Right1(moveAngle,anyA1,moveAngle); // legs down
        setRight2Left1(anyA2,anyA0,anyA2); // legs up
        if (lowerIncCnt > 0) {lowerLeft2Right1();}
      } else {
        // right side primary
        setLeft2Right1(anyA0,anyA2,anyA0); // legs up
        setRight2Left1(anyA1,moveAngle,anyA1); // legs down
        if (lowerIncCnt > 0) {lowerRight2Left1();}
      }
      if (moveAngle >= 90) {
        // at end of swing
        moveAngle = anyA0; moveAngleFP = 90;
        raiseIncCnt = 5;
        if (moveSide > 0) {
          raiseLeft2Right1(); moveSide = 0; // left side primary
        } else {
          raiseRight2Left1(); moveSide = 1; // right side primary
        }
        moveWalk = 2; // go back to non-overlapped phase
      } break;
  }
  // adjust 'Move' loop timing rate based on JoyX
  if ((anyCalc > 0) && (JoyX < JoyCentreLL)){
    unsigned long zVal = JoyX;
    if (JoyX < 50) {
      // lower controller shapping - quick band
      if (speedTQ > 0) {
        // 'Quick' mode
        zVal = (zVal * 6000) / 49;
        zVal = 4000 + zVal;
      } else {
        // 'Tortoise' mode
        zVal = (zVal * 6000) / 49;
        zVal = 12000 + zVal;
      }
    } else {
      // upper controller shapping - slow band
      if (speedTQ > 0) {
        // 'Quick' mode
        zVal = (zVal - 49) * 40000;
        zVal = zVal/49;
        zVal = 10000 + zVal;
      } else {
        // 'Tortoise' mode
        zVal = (zVal - 49) * 32000;
        zVal = zVal/49;
        zVal = 18000 + zVal;
      }
    }
    zVal = max(zVal,3000);
    if (moveInterval != zVal) {
      moveInterval = zVal;
//      Serial.print("moveInterval = "); Serial.println(moveInterval);
    }
    // Variable heigh adjustment
//    raiseAngleVar = (raiseAngle - raiseAngleLL) * (JoyCentreLL - JoyX);
//    raiseAngleVar = raiseAngle - (raiseAngleVar/JoyCentreLL);
  }
  // test for 'Right Turn' demand on JoyPad
  if (JoyX > JoyCentreLL){
    // reverse direction so reset shoulder angles and exit
    moveToReady(); moveMode = 0;
  }
  // test for no demand on JoyPad
  if ((JoyX > JoyCentreLL) && (JoyX < JoyCentreUL) && (JoyY > JoyCentreLL) && (JoyY < JoyCentreUL)){
    // stationary so exit moving forward
    moveMode = 0;
  }
}

// ----------------------------------------------------------------------

void moveTurnRight() {
  // right turn in a circular manner at a pace set by JoyY
  moved = 400; // set 'Rest' time-out to 2s
  anyCalc = 0; // restrict calculations to specific moveWalks
  switch (moveWalk) {
    case 0:
      // move legs to stride position
      SetToLegPos(strideAngleVar); 
      moveWalk++; setRGBEnh(); setMovePause(20); break;
    case 1:
      // raise three legs
      anyVal = random(2); // randomly decide which start side
      if (anyVal < 1) {
        raiseRight2Left1(); moveSide = 0; // left side primary
      } else {
        raiseLeft2Right1(); moveSide = 1; // right side primary
      } moveWalk++; setMovePause(10);
      moveAngleMu = 1.0; break;
    case 2:
      // move shoulders in non-overlapped region
      // when turning we need to generate 4 angles
      anyCalc = 1; moveAngle++;
      if (moveAngle == restAngle) {moveAngleFP = float(restAngle);} // resynch
      anyA1 = restAngle + restAngle - moveAngle;
      if (moveAngleFP > 40.0) {
        moveAngleFP -= moveIncFP;
        anyFP = float(restAngle);
        anyFP = anyFP + anyFP - moveAngleFP;
      } anyA0 = int(moveAngleFP); anyA2 = int(anyFP);
      if (moveSide < 1) {
        // left side primary
        setLeft2Right1(moveAngle,anyA1,moveAngle); // legs down
        setRight2Left1(anyA2,anyA0,anyA2); // legs up
        if (raiseIncCnt > 0) {raiseRight2Left1();}
      } else {
        // right side primary
        setLeft2Right1(anyA0,anyA2,anyA0); // legs up
        setRight2Left1(anyA1,moveAngle,anyA1); // legs down
        if (raiseIncCnt > 0) {raiseLeft2Right1();}
      }
      if (moveAngle >= 86) {
        // hit overlap region so drop raised legs
        lowerIncCnt = 5;
        if (moveSide < 1) {
          lowerRight2Left1();
        } else {
          lowerLeft2Right1();
        } moveWalk++;
      } break;
    case 3:
      // move shoulders in overlapped region
      anyCalc = 1;
      moveAngle++; anyA0 = moveAngle - 47;
      anyA1 = 83 - anyA0; anyA2 = 177 - moveAngle;
      if (moveSide < 1) {
        // left side primary
        setLeft2Right1(moveAngle,anyA1,moveAngle); // legs down
        setRight2Left1(anyA2,anyA0,anyA2); // legs up
        if (lowerIncCnt > 0) {lowerRight2Left1();}
      } else {
        // right side primary
        setLeft2Right1(anyA0,anyA2,anyA0); // legs up
        setRight2Left1(anyA1,moveAngle,anyA1); // legs down
        if (lowerIncCnt > 0) {lowerLeft2Right1();}
      }
      if (moveAngle >= 90) {
        // at end of swing
        moveAngle = anyA0; moveAngleFP = 90;
        raiseIncCnt = 5;
        if (moveSide > 0) {
          raiseRight2Left1(); moveSide = 0; // left side primary
        } else {
          raiseLeft2Right1(); moveSide = 1; // right side primary
        }
        moveWalk = 2; // go back to non-overlapped phase
      } break;
  }
  // adjust 'Move' loop timing rate based on JoyX
  if ((anyCalc > 0) && (JoyX > JoyCentreUL)){
    unsigned long zVal = JoyX;
    if (JoyX < 206) {
      // lower controller shapping - slow band
      if (speedTQ > 0) {
        // 'Quick' mode
        zVal = 40000 * (zVal - JoyCentreUL);
        zVal = zVal/(206-JoyCentreUL);
        zVal = 50000 - zVal;
      } else {
        // 'Tortoise' mode
        zVal = 32000 * (zVal - JoyCentreUL);
        zVal = zVal/(206-JoyCentreUL);
        zVal = 50000 - zVal;
      }
    } else {
      // upper controller shapping - quick band
      if (speedTQ > 0) {
        // 'Quick' mode
        zVal = 11877 * (zVal - JoyCentreUL);
        zVal = zVal/(255-JoyCentreUL);
        zVal = 15877 - zVal;
      } else {
        // 'Tortoise' mode
        zVal = 11877 * (zVal - JoyCentreUL);
        zVal = zVal/(255-JoyCentreUL);
        zVal = 23877 - zVal;
      }
    }
    zVal = max(zVal,3000);
    if (moveInterval != zVal) {
      moveInterval = zVal;
//      Serial.print("moveInterval = "); Serial.println(moveInterval);
    }
    // Variable heigh adjustment
//    raiseAngleVar = (raiseAngle - raiseAngleLL) * (JoyX - JoyCentreUL);
//    raiseAngleVar = raiseAngle - (raiseAngleVar/(255 - JoyCentreUL));
  }
  // test for 'Left Turn' demand on JoyPad
  if (JoyX < JoyCentreUL){
    // reverse direction so reset shoulder angles and exit
    moveToReady(); moveMode = 0;
  }
  // test for no demand on JoyPad
  if ((JoyX > JoyCentreLL) && (JoyX < JoyCentreUL) && (JoyY > JoyCentreLL) && (JoyY < JoyCentreUL)){
    // stationary so exit moving forward
    moveMode = 0;
  }
}

// ----------------------------------------------------------------------

void raiseLeft2Right1() {
  // raise front and rear left legs and centre right
  long zraiseAngle = raiseAngleVar; // default max movement
  switch (raiseIncCnt) {
    case 1: zraiseAngle = raiseAngleVar; break;
    case 2: zraiseAngle = ((4*(raiseAngleVar-strideAngleVar))/5)+strideAngleVar; break;
    case 3: zraiseAngle = ((3*(raiseAngleVar-strideAngleVar))/5)+strideAngleVar; break;
    case 4: zraiseAngle = ((2*(raiseAngleVar-strideAngleVar))/5)+strideAngleVar; break;
    case 5: zraiseAngle = ((raiseAngleVar-strideAngleVar)/5)+strideAngleVar; break;
  } raiseIncCnt--; // decrement pointer for next call
  SetServoAngle(4, zraiseAngle); // raise front left leg
  SetServoAngle(6, zraiseAngle); // raise centre right leg
  SetServoAngle(12, zraiseAngle); // raise rear left leg
}

// ----------------------------------------------------------------------

void raiseRight2Left1() {
  // raise front and rear right legs and centre left
  long zraiseAngle = raiseAngleVar; // default max movement
  switch (raiseIncCnt) {
    case 1: zraiseAngle = raiseAngleVar; break;
    case 2: zraiseAngle = ((4*(raiseAngleVar-strideAngleVar))/5)+strideAngleVar; break;
    case 3: zraiseAngle = ((3*(raiseAngleVar-strideAngleVar))/5)+strideAngleVar; break;
    case 4: zraiseAngle = ((2*(raiseAngleVar-strideAngleVar))/5)+strideAngleVar; break;
    case 5: zraiseAngle = ((raiseAngleVar-strideAngleVar)/5)+strideAngleVar; break;
  } raiseIncCnt--; // decrement pointer for next call
  SetServoAngle(2, zraiseAngle); // raise front right leg
  SetServoAngle(8, zraiseAngle); // raise centre left leg
  SetServoAngle(10, zraiseAngle); // raise rear right leg
}

// ----------------------------------------------------------------------

void setLeft2Right1(int zA, int zB, int zC) {
  // set front and rear left shoulders and centre right shoulder
  SetServoAngle(3, zA); // set front left shoulder
  SetServoAngle(5, zB); // set centre right shoulder
  SetServoAngle(11, zC); // set rear left shoulder
}

// ----------------------------------------------------------------------

void setMoveBackward() {
  // initialise 'Move' engine for backward motion
  moveAngle = restAngle; moveWalk = 0; // initialise counters and pointers
  moveAngleFP = float(restAngle);
  moveIncFP = 1.13635;
  moveMode = modeBackward; // set main mode to 'Backward'
  moveInterval = 50000; // start slow
  moveToReady();
}

// ----------------------------------------------------------------------

void setMoveForward() {
  // initialise 'Move' engine for forward motion
  moveAngle = restAngle; moveWalk = 0; // initialise counters and pointers
  moveAngleFP = float(restAngle);
  moveIncFP = 1.13635;
  moveMode = modeForward; // set main mode to 'Forward'
  moveInterval = 50000; // start slow
  moveToReady();
}

// ----------------------------------------------------------------------

void setMovePause(int zTime) {
  // called to set a pause in the 'Move' engine
  moveNext = moveMode; // mode to use after pause time-out  
  movePause = zTime; // time to pause in loop cycles
  moveMode = modePause; // set mode to pause count-down
}

// ----------------------------------------------------------------------

void setMoveTurnLeft() {
  // initialise 'Move' engine for turning left motion
  moveAngle = restAngle; moveWalk = 0; // initialise counters and pointers
  moveAngleFP = float(restAngle);
  moveIncFP = 1.13635;
  moveMode = modeTurnLft; // set main mode to 'Forward'
  moveInterval = 50000; // start slow
  moveToReady();
}

// ----------------------------------------------------------------------

void setMoveTurnRight() {
  // initialise 'Move' engine for turning right motion
  moveAngle = restAngle; moveWalk = 0; // initialise counters and pointers
  moveAngleFP = float(restAngle);
  moveIncFP = 1.13635;
  moveMode = modeTurnRht; // set main mode to 'Forward'
  moveInterval = 50000; // start slow
  moveToReady();
}

// ----------------------------------------------------------------------

void setRight2Left1(int zA, int zB, int zC) {
  // set front and rear right shoulders and centre left shoulder
  SetServoAngle(1, zA); // set front right shoulder
  SetServoAngle(7, zB); // set centre left shoulder
  SetServoAngle(9, zC); // set rear right shoulder
}

// ----------------------------------------------------------------------



